{
open Parser
exception Eof
}

rule token = parse
	| '<' ['B' 'I' 'S' 'U' '0'-'9' 'r' 'g' 'b' 'c' 'm' 'y' 'k' 'w'] '>'
		{ let ch = Lexing.lexeme_char lexbuf 1 in
			if ch = 'B' then B
			else if ch = 'I' then I
			else if ch = 'S' then S
			else if ch = 'U' then U
			else if ch = '0' then SIZE0
			else if ch = '1' then SIZE1
			else if ch = '2' then SIZE2
			else if ch = '3' then SIZE3
			else if ch = '4' then SIZE4
			else if ch = '5' then SIZE5
			else if ch = '6' then SIZE6
			else if ch = '7' then SIZE7
			else if ch = '8' then SIZE8
			else if ch = '9' then SIZE9
			else if ch = 'r' then COLORR
			else if ch = 'g' then COLORG
			else if ch = 'b' then COLORB
			else if ch = 'c' then COLORC
			else if ch = 'm' then COLORM
			else if ch = 'y' then COLORY
			else if ch = 'k' then COLORK
			else if ch = 'w' then COLORW
			else raise (Failure "can't happen #1")
		}
	| "</" ['B' 'I' 'S' 'U' '0'-'9' 'r' 'g' 'b' 'c' 'm' 'y' 'k' 'w'] '>'
		{ let ch = Lexing.lexeme_char lexbuf 2 in
			if ch = 'B' then ENDB
			else if ch = 'I' then ENDI
			else if ch = 'S' then ENDS
			else if ch = 'U' then ENDU
			else if ch = '0' then ENDSIZE0
			else if ch = '1' then ENDSIZE1
			else if ch = '2' then ENDSIZE2
			else if ch = '3' then ENDSIZE3
			else if ch = '4' then ENDSIZE4
			else if ch = '5' then ENDSIZE5
			else if ch = '6' then ENDSIZE6
			else if ch = '7' then ENDSIZE7
			else if ch = '8' then ENDSIZE8
			else if ch = '9' then ENDSIZE9
			else if ch = 'r' then ENDCOLORR
			else if ch = 'g' then ENDCOLORG
			else if ch = 'b' then ENDCOLORB
			else if ch = 'c' then ENDCOLORC
			else if ch = 'm' then ENDCOLORM
			else if ch = 'y' then ENDCOLORY
			else if ch = 'k' then ENDCOLORK
			else if ch = 'w' then ENDCOLORW
			else raise (Failure "can't happen #2")
		}
	| "<EM>"				{ EM }
	| "</EM>"				{ ENDEM }
	| "<PL>"				{ PL }
	| "</PL>"				{ ENDPL }
	| "<TT>"				{ TT }
	| "</TT>"				{ ENDTT }
	| [^ '<' '>' ]+
		{ TEXT (Lexing.lexeme lexbuf) }
	| eof					{ ETX }
