%{
open Structure
%}

%token WHITESPACE
%token B ENDB
%token EM ENDEM
%token I ENDI
%token PL ENDPL
%token S ENDS
%token TT ENDTT
%token U ENDU
%token SIZE0 ENDSIZE0
%token SIZE1 ENDSIZE1
%token SIZE2 ENDSIZE2
%token SIZE3 ENDSIZE3
%token SIZE4 ENDSIZE4
%token SIZE5 ENDSIZE5
%token SIZE6 ENDSIZE6
%token SIZE7 ENDSIZE7
%token SIZE8 ENDSIZE8
%token SIZE9 ENDSIZE9
%token COLORR ENDCOLORR
%token COLORG ENDCOLORG
%token COLORB ENDCOLORB
%token COLORC ENDCOLORC
%token COLORM ENDCOLORM
%token COLORY ENDCOLORY
%token COLORK ENDCOLORK
%token COLORW ENDCOLORW
%token <string> TEXT
%token ETX

%start main
%type <Structure.t list> main

%%

main:
	document ETX				{ $1 }
	;


document: /*empty*/				{ [] }
	| docitem					{ [ $1 ] }
	| docitem document			{ $1 :: $2 }
	;


docitem: TEXT					{ Text $1 }
	| B document ENDB			{ Bold $2 }
	| EM document ENDEM			{ Emphasis $2 }
	| I document ENDI			{ Italic $2 }
	| PL document ENDPL			{ Plain $2 }
	| S document ENDS			{ Strong $2 }
	| TT document ENDTT			{ Typewriter $2 }
	| U document ENDU			{ Underline $2 }
	| SIZE0 document ENDSIZE0	{ Size (0,$2) }
	| SIZE1 document ENDSIZE1	{ Size (1,$2) }
	| SIZE2 document ENDSIZE2	{ Size (2,$2) }
	| SIZE3 document ENDSIZE3	{ Size (3,$2) }
	| SIZE4 document ENDSIZE4	{ Size (4,$2) }
	| SIZE5 document ENDSIZE5	{ Size (5,$2) }
	| SIZE6 document ENDSIZE6	{ Size (6,$2) }
	| SIZE7 document ENDSIZE7	{ Size (7,$2) }
	| SIZE8 document ENDSIZE8	{ Size (8,$2) }
	| SIZE9 document ENDSIZE9	{ Size (9,$2) }
	| COLORR document ENDCOLORR { Red $2 }
	| COLORG document ENDCOLORG { Green $2 }
	| COLORB document ENDCOLORB { Blue $2 }
	| COLORC document ENDCOLORC { Cyan $2 }
	| COLORM document ENDCOLORM { Magenta $2 }
	| COLORY document ENDCOLORY { Yellow $2 }
	| COLORK document ENDCOLORK { Black $2 }
	| COLORW document ENDCOLORW { White $2 }
	;
